package com.senter.demo.uhf.modelD2;

import android.os.Bundle;

import com.senter.demo.uhf.common.Activity1ReadCommonAbstract;
import com.senter.demo.uhf.common.DestinationTagSpecifics;
import com.senter.demo.uhf.common.DestinationTagSpecifics.TargetTagType;
import com.senter.iot.support.openapi.uhf.UhfD2;
import com.senter.iot.support.openapi.uhf.UhfD2.Bank;
import com.senter.iot.support.openapi.uhf.UhfD2.UII;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdEpcMatchSetting;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdErrorCode;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdFrequencyPoint;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdOnIso18k6cRead;

public class Activity1Read extends Activity1ReadCommonAbstract {
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }
    
    protected DestinationTagSpecifics.TargetTagType[] getDestinationType() {
        return new TargetTagType[]{TargetTagType.SingleTag, TargetTagType.SpecifiedTag};
    }
    
    @Override
    protected void onRead(Bank bank, int ptr, int cnt) {
        if (getDestinationTagSpecifics().isOrderedUii()) {
            UII uii = getDestinationTagSpecifics().getDstTagUiiIfOrdered();
            
            Boolean boolean1 = UhfD2.getInstance().iso18k6cSetAccessEpcMatch(UmdEpcMatchSetting.newInstanceOfMatchingEpcFieldInUii(uii.getEpc().getBytes()));
            
            if (boolean1 == null || boolean1 == false) {
                showToast("failed");
                return;
            }
        }
        
        UhfD2.getInstance().iso18k6cRead(getDestinationTagSpecifics().getAccessPassword(), bank, ptr, cnt, new UmdOnIso18k6cRead() {
            
            @Override
            public void onFailed(UmdErrorCode error) {
                showToast("error:" + error.name());
            }
            
            @Override
            public void onTagRead(int tagCount, UII uii, byte[] data, UmdFrequencyPoint frequencyPoint, Integer antennaId, int readCount) {
                addNewMassageToListview(uii, data);
            }
        });
    }
}
