package com.senter.demo.uhf.modelD2;

import android.os.Bundle;
import android.view.View;

import com.senter.demo.uhf.App;
import com.senter.demo.uhf.common.Activity2WriteCommonAbstract;
import com.senter.demo.uhf.common.DestinationTagSpecifics.TargetTagType;
import com.senter.iot.support.openapi.uhf.UhfD2;
import com.senter.iot.support.openapi.uhf.UhfD2.Bank;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdEpcMatchSetting;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdErrorCode;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdFrequencyPoint;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdOnIso18k6cWrite;
import com.senter.iot.support.openapi.uhf.UhfD2.UII;

public class Activity2WriteEpc extends Activity2WriteCommonAbstract {
    @SuppressWarnings("unused")
    private static final String Tag = "Activity2Write";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        bankPointerView.setVisibility(View.GONE);
        bankSpinner.setSelection(1);//选择Epc分区
        ptrEditText.setText("1");//起始地址写成1
    }

    protected TargetTagType[] getDestinationType() {
        return new TargetTagType[]{TargetTagType.SingleTag, TargetTagType.SpecifiedTag};
    }


    @Override
    protected void onWrite(Bank bank, int offset, byte[] data) {
        if (getDestinationTagSpecifics().isOrderedUii()) {
            UII uii = getDestinationTagSpecifics().getDstTagUiiIfOrdered();

            Boolean boolean1 = UhfD2.getInstance().iso18k6cSetAccessEpcMatch(UmdEpcMatchSetting.newInstanceOfMatchingEpcFieldInUii(uii.getEpc().getBytes()));

            if (boolean1 == null || boolean1 == false) {
                showToast("failed");
                return;
            }
        }
    
        UhfD2.getInstance().iso18k6cWrite(getDestinationTagSpecifics().getAccessPassword(), bank, offset, data, new UmdOnIso18k6cWrite() {
            @Override
            public void onFailed(UmdErrorCode error) {
                showToast("error:" + error.name());
            }

            @Override
            public void onTagWrite(int tagCount, UII uii, UmdErrorCode errorCode, UmdFrequencyPoint frequencyPoint, Integer antennaId, int writeCount) {
                if (errorCode == UmdErrorCode.command_success) {
                    addNewMassageToListview(uii, writeCount);
                } else {
                    addNewMassageToListview(uii, errorCode.name());
                }
            }
        });

    }
}
