package com.senter.demo.uhf.modelD2;

import com.senter.demo.uhf.common.DestinationTagSpecifics;
import com.senter.demo.uhf.common.DestinationTagSpecifics.TargetTagType;
import com.senter.demo.uhf.util.DataTransfer;
import com.senter.iot.support.openapi.uhf.UhfD2;
import com.senter.iot.support.openapi.uhf.UhfD2.UII;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdEpcMatchSetting;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdErrorCode;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdFrequencyPoint;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdOnIso18k6cKill;

public class Activity4Kill extends com.senter.demo.uhf.common.Activity6KillCommonAbstract {
    protected DestinationTagSpecifics.TargetTagType[] getDestinationType() {
        return new DestinationTagSpecifics.TargetTagType[]{TargetTagType.SingleTag, TargetTagType.SpecifiedTag};
    }

    @Override
    protected void onKill() {
        if (getDestinationTagSpecifics().isOrderedUii()) {
            UII uii = getDestinationTagSpecifics().getDstTagUiiIfOrdered();

            Boolean boolean1 = UhfD2.getInstance().iso18k6cSetAccessEpcMatch(UmdEpcMatchSetting.newInstanceOfMatchingEpcFieldInUii(uii.getEpc().getBytes()));

            if (boolean1 == null || boolean1 == false) {
                showToast("failed");
                return;
            }
        }

        UhfD2.getInstance().iso18k6cKill(getDestinationTagSpecifics().getKillPassword(), new UmdOnIso18k6cKill() {
            @Override
            public void onFailed(UmdErrorCode error) {
                showToast("kill error");
            }

            @Override
            public void onTagKill(int tagCount, UII uii, UmdErrorCode errorCode, UmdFrequencyPoint frequencyPoint, Integer antennaId, int killCount) {
                addNewMassageToListview("Killed:" + DataTransfer.xGetString(uii.getBytes()));
            }
        });
    }
}
