package com.senter.demo.uhf.modelD2;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.LinearLayout;

import com.senter.demo.common.misc.ActivityHelper;
import com.senter.demo.uhf.R;
import com.senter.demo.uhf.modelD2.ConfigurationSettingsOfModelD2.Protocol;
import com.senter.iot.support.openapi.uhf.UhfD2;


public class Activity_FunctionSelection extends Activity {
    
    private final ConfigurationSettingsOfModelD2 mConfigurationSettingsOfModelD2 = ConfigurationSettingsOfModelD2.getInstance();
    
    private Protocol mCurrentProtocolOfModelD2 = null;
    
    private ActivityHelper<Activity_FunctionSelection> ah = new ActivityHelper<Activity_FunctionSelection>(this);
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        boolean isSuccess = UhfD2.getInstance().init();
        if (!isSuccess) {
            ah.showToastLong("init failed");
            finish();
        }
    }
    
    @Override
    protected void onDestroy() {
        super.onDestroy();
        UhfD2.getInstance().uninit();
    }
    
    @Override
    protected void onResume() {
        onCreateInitViews();
        super.onResume();
    }
    
    private class Views {
        public Views() {
            if ((mConfigurationSettingsOfModelD2.usingProtocol() == Protocol.I8k6c) && (mCurrentProtocolOfModelD2 == Protocol.I8k6c)) {
                return;
            } else if ((mConfigurationSettingsOfModelD2.usingProtocol() == Protocol.I8k6b) && (mCurrentProtocolOfModelD2 == Protocol.I8k6b)) {
                return;
            } else {
                //through down
            }
            
            setContentView(R.layout.activity1_function_selection_d2);
            
            View tv6CTag, tv6BTag;
            View glApps6C, glApps6B;
            
            LinearLayout ll;
            
            tv6CTag = findViewById(R.id.idMain2ActivityD26C_tv6CTag);
            tv6BTag = findViewById(R.id.idMain2ActivityD26C_tv6BTag);
            glApps6C = findViewById(R.id.idMain2ActivityD26C_glApps);
            glApps6B = findViewById(R.id.idMain2ActivityD26B_glApps);
            
            if (mConfigurationSettingsOfModelD2.usingProtocol() == Protocol.I8k6c) {// 6C
                mCurrentProtocolOfModelD2 = Protocol.I8k6c;
                
                tv6BTag.setVisibility(View.GONE);
                glApps6B.setVisibility(View.GONE);
                
                tv6CTag.setVisibility(View.VISIBLE);
                glApps6C.setVisibility(View.VISIBLE);
                
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD2_glApps_inInventory);
                ll.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6C_0Inventory();
                    }
                });
                
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD2_glApps_inRead);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6C_1Read();
                    }
                });
                
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD2_glApps_inReadMulti);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6C_1ReadMulti();
                    }
                });
                
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD2_glApps_inWrite);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6C_2Write();
                    }
                });
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD2_glApps_inWriteEpc);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6C_2WriteEpc();
                    }
                });
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD2_glApps_inLock);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6C_4Lock();
                    }
                });
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD2_glApps_inKill);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6C_6Kill();
                    }
                });
                
            } else if (mConfigurationSettingsOfModelD2.usingProtocol() == Protocol.I8k6b) {// 6B
                
                mCurrentProtocolOfModelD2 = Protocol.I8k6b;
                tv6BTag.setVisibility(View.VISIBLE);
                glApps6B.setVisibility(View.VISIBLE);
                
                tv6CTag.setVisibility(View.GONE);
                glApps6C.setVisibility(View.GONE);
                
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD26b_glApps_inInventory);
                ll.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6B_0Inventory();
                    }
                });
                
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD26b_glApps_inRead);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6B_1Read();
                    }
                });
                
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD26b_glApps_inWrite);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6B_2Write();
                    }
                });
                
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD26b_glApps_inLock);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6B_3Lock();
                    }
                });
                ll = (LinearLayout) findViewById(R.id.idMain2ActivityD26b_glApps_inUnlock);
                ll.setOnClickListener(new OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        onIso6B_4QuearyLock();
                    }
                });
            } else {
                throw new IllegalStateException();
            }
            
            ll = (LinearLayout) findViewById(R.id.idMain2ActivityD2_glApps_inSettings);
            ll.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {
                    onActivitySettings();
                }
            });
        }
    }
    
    private void onCreateInitViews() {
        new Views();
    }
    
    private void onIso6C_0Inventory() {
        ah.startActivity(com.senter.demo.uhf.modelD2.Activity0Inventory.class);
    }
    
    private void onIso6C_1Read() {
        ah.startActivity(com.senter.demo.uhf.modelD2.Activity1Read.class);
    }
    
    private void onIso6C_1ReadMulti() {
        ah.startActivity(com.senter.demo.uhf.modelD2.Activity1ReadMultiActivity.class);
    }
    
    private void onIso6C_2Write() {
        ah.startActivity(com.senter.demo.uhf.modelD2.Activity2Write.class);
    }
    
    private void onIso6C_2WriteEpc() {
        ah.startActivity(com.senter.demo.uhf.modelD2.Activity2WriteEpc.class);
    }
    
    private void onIso6C_4Lock() {
        ah.startActivity(com.senter.demo.uhf.modelD2.Activity3Lock.class);
    }
    
    private void onIso6C_6Kill() {
        ah.startActivity(com.senter.demo.uhf.modelD2.Activity4Kill.class);
    }
    
    private void onActivitySettings() {
        ah.startActivity(com.senter.demo.uhf.modelD2.Activity5Settings.class);
    }
    
    private void onIso6B_0Inventory() {
        ah.startActivity(com.senter.demo.uhf.modelD2.iso18k6b.Activity0Inventory.class);
    }
    
    private void onIso6B_1Read() {
        ah.startActivity(com.senter.demo.uhf.modelD2.iso18k6b.Activity1Read.class);
    }
    
    private void onIso6B_2Write() {
        ah.startActivity(com.senter.demo.uhf.modelD2.iso18k6b.Activity2Write.class);
    }
    
    private void onIso6B_3Lock() {
        ah.startActivity(com.senter.demo.uhf.modelD2.iso18k6b.Activity3Lock.class);
    }
    
    private void onIso6B_4QuearyLock() {
        ah.startActivity(com.senter.demo.uhf.modelD2.iso18k6b.Activity4QueryLock.class);
    }
    
}
