package com.senter.demo.uhf.modelD2.iso18k6b;

import android.os.Bundle;
import android.util.Log;

import com.senter.demo.uhf.util.DataTransfer;
import com.senter.iot.support.openapi.uhf.UhfD2;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdErrorCode;
import com.senter.iot.support.openapi.uhf.UhfD2.UmdOnIso18k6bInventory;
import com.senter.support.openapi.StKeyManager;

public class Activity0Inventory extends com.senter.demo.uhf.common.Activity0InventoryCommonAbstract {
    
    StKeyManager.ShortcutKeyMonitor monitorScan = StKeyManager.ShortcutKeyMonitor.isShortcutKeyAvailable(StKeyManager.ShortcutKey.Scan) ?
            StKeyManager.getInstanceOfShortcutKeyMonitor(StKeyManager.ShortcutKey.Scan) : null;
    StKeyManager.ShortcutKeyMonitor monitorScanHandle = StKeyManager.ShortcutKeyMonitor.isShortcutKeyAvailable(StKeyManager.ShortcutKey.Scan_Handle) ?
            StKeyManager.getInstanceOfShortcutKeyMonitor(StKeyManager.ShortcutKey.Scan_Handle) : null;
    
    private boolean isScaning;
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getViews().setModes(InventoryMode.Custom);
        if (monitorScan != null) monitorScan.reset(this, listener, null);
        if (monitorScanHandle != null) monitorScanHandle.reset(this, listener, null);
    }
    
    @Override
    protected void uiOnInverntryButton() {
        startInventory();
    }
    
    
    private void startInventory() {
//		Log.e("", "Activity0Inventory: startInventory");
//		getViews().enableInventoryButton(false);
//		viewsSetAsStarted();
        
        UhfD2.getInstance().iso18k6bInventory(new UmdOnIso18k6bInventory() {
            
            @Override
            public void onTagInventory(Iso18k6bInventoryResult rslt, int antId) {
                Log.e("", "onTagInventory:" + DataTransfer.xGetString(rslt.getUid().getBytes()));
                addNewUiiMassageToListview("Uid:" + DataTransfer.xGetString(rslt.getUid().getBytes()));
            }
            
            @Override
            public void onFinishedWithError(UmdErrorCode error) {
//				Log.e("", "onFinishedWithError:"+error);
//				getViews().enableInventoryButton(true);
//				viewsSetAsStoped();
            }
            
            @Override
            public void onFinishedSuccessfully(int antId, int tagFound) {
//				Log.e("", "onFinishedSuccessfully:"+tagFound);
//				getViews().enableInventoryButton(true);
//				viewsSetAsStoped();
            }
        });
    }
    
    @Override
    protected void onResume() {
        super.onResume();
        if (monitorScan != null) {
            monitorScan.startMonitor();
        }
        if (monitorScanHandle != null) {
            monitorScanHandle.startMonitor();
        }
        
    }
    
    @Override
    protected void onPause() {
        super.onPause();
        if (monitorScan != null) {
            monitorScan.stopMonitor();
        }
        if (monitorScanHandle != null) {
            monitorScanHandle.stopMonitor();
        }
    }
    
    
    StKeyManager.ShortcutKeyMonitor.ShortcutKeyListener listener = new StKeyManager.ShortcutKeyMonitor.ShortcutKeyListener() {
        
        public void onKeyDown(int keycode, int repeatCount, StKeyManager.ShortcutKeyMonitor.ShortcutKeyEvent event) {
            if (isScaning == false) {
                uiOnInverntryButton();
                isScaning = true;
            }
        }
        
        public void onKeyUp(int keycode, int repeatCount, StKeyManager.ShortcutKeyMonitor.ShortcutKeyEvent event) {
            isScaning = false;
        }
        
    };
    
}
